﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using WpfVirtualEarth;

namespace WpfApplication7
{
  public partial class Window1 : Window
  {
    public Window1()
    {
      InitializeComponent();
    }
    void OnPostCodeLookup(object sender, EventArgs args)
    {
      veControl.BeginLookupPostCode(txtPostcode.Text, Callback, txtPostcode.Text);
    }
    void Callback(IAsyncResult result)
    {
      try
      {
        PostCodeLookupResult postCode = veControl.EndLookupPostCode(result);

        txtAddLat.Text = postCode.Latitude.ToString();
        txtAddLon.Text = postCode.Longitude.ToString();
      }
      catch (Exception e)
      {
        MessageBox.Show(e.Message);
      }
    }
    void OnRemovePushPin(object sender, EventArgs args)
    {
      PushPin p = lstPins.SelectedValue as PushPin;

      if (p != null)
      {
        veControl.PushPins.Remove(p);
      }
    }
    void OnAddPushPin(object sender, EventArgs args)
    {
      try
      {
        PushPin p = new PushPin()
        {
          Latitude = double.Parse(txtAddLat.Text),
          Longitude = double.Parse(txtAddLon.Text),
          Text = txtAddName.Text
        };
        veControl.PushPins.Add(p);
      }
      catch
      {
      }
    }
    void OnCentrePushPin(object sender, EventArgs args)
    {
      PushPin p = lstPins.SelectedValue as PushPin;

      if (p != null)
      {
        p.CenterInMap();
      }
    }
    void OnGetDistance(object sender, EventArgs args)
    {
      if ((lstPins.SelectedItems != null) &&
        (lstPins.SelectedItems.Count == 2))
      {
        PushPin p1 = lstPins.SelectedItems[0] as PushPin;
        PushPin p2 = lstPins.SelectedItems[1] as PushPin;

        if ((p1 != null) && (p2 != null))
        {
          veControl.BeginFindDistance(p1, p2, GetDistanceCallback, null);
        }
      }
    }
    void GetDistanceCallback(IAsyncResult result)
    {
      try
      {
        DistanceLookupResult distanceResult = veControl.EndFindDistance(result);

        txtDistance.Text = distanceResult.Distance.ToString();
        txtTime.Text = (distanceResult.Time / 3600).ToString();
      }
      catch (Exception ex)
      {
        MessageBox.Show(ex.Message);
      }
    }
  }
}